//-----------------------------------------------------------------------------
/*
 * Description: This file contains the class Ax::Tools::Trace
 *
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   07.09.2003
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2006-03-04 12:36:48 +0100 (Sa, 04 Mär 2006) $
 *   $Revision: 187 $
 */
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//     includes
//-----------------------------------------------------------------------------

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
#include <stdio.h>
#include <stdarg.h>
#include <syslog.h>

//----- AxLib -----------------------------------------------------------------
#include <Ax/Tools/Trace.h>

//----- local -----------------------------------------------------------------

//=============================================================================
//     locals
//=============================================================================

//-----------------------------------------------------------------------------
//     LogFunctionPtr
//-----------------------------------------------------------------------------
AxTSysLogFunc AxSysLog = 0; //syslog;

//-----------------------------------------------------------------------------
//     Helper to enforce initialisation of AxSysLog
//-----------------------------------------------------------------------------
class AxSetLog
{
  public:
    AxSetLog();
};

AxSetLog::AxSetLog()
{
  Ax::Tools::Trace::setLogFunc(syslog);
} // AxSetLog::AxSetLog()

static AxSetLog SetLogHelper;

//=============================================================================
//     namespaces
//=============================================================================
namespace Ax
{
namespace Tools
{
//---------------------------------------------------------------------
//     Trace::setLogFunc()
//---------------------------------------------------------------------
void Trace::setLogFunc(AxTSysLogFunc theLogFunc)
{
  if (theLogFunc != 0)
  {
    AxSysLog = theLogFunc;
  }
  else
  {
    AxSysLog = syslog;
  } // if

#if 0
  if (AxSysLog == syslog)
  {
    (*AxSysLog)(LOG_DEBUG, "Setting log to syslog()");
  }
  else
  {
    (*AxSysLog)(LOG_DEBUG, "Setting log to given function");
  } // if
#endif
} // Trace::setLogFunc()

}; // namespace Tools
}; // namespace Ax
